package GUIPack;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import serverClient.*;

/**
 * S_GUI is the graphical user interface for the server of this tetris. It builds up the window with its different elements.
 * It also starts a new Thread for the Server_connectClient class.
 *
 * @author Winkler
 */
public class S_GUI extends JFrame implements ActionListener
{
	private JFrame mainFrame;
	private static JPanel mainPanel, tfPanel, labelPanel, buttonPanel, prefPanel, radioPanel, rbPanel, rlabelPanel;
	private JTextField numberOfClientsTF;
	private JLabel numberOfClientsLabel, rbLabel;
	private JButton startGameB;
	private JRadioButton yrb, nrb;

	private static final long serialVersionUID = 13L;

	//Der Constructor erstellt im Prinzip das gesame GUI des Servers (siehe auch Client)
	public S_GUI()
	{
		//Create and set up the window.
		mainFrame = new JFrame("TetrisServer");
		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);


		//mainPanel bestimmt die groe�e des fensters
		mainPanel = new JPanel();
		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS ));
		mainPanel.setMinimumSize(new Dimension(330, 100));
		mainPanel.setMaximumSize(new Dimension(330, 100));
		mainPanel.setPreferredSize(new Dimension(330, 100));
		mainPanel.setBackground(Color.lightGray);

		//stehen die Labels und Textfelder drin
		prefPanel = new JPanel();
		prefPanel.setLayout(new BoxLayout(prefPanel, BoxLayout.X_AXIS ));
		prefPanel.setMinimumSize(new Dimension(330, 50));
		prefPanel.setMaximumSize(new Dimension(330, 50));
		prefPanel.setPreferredSize(new Dimension(330, 50));
		prefPanel.setBackground(Color.lightGray);

		//versuch ein RadioButtonPanel zu machen

		radioPanel = new JPanel();
		radioPanel.setLayout(new BoxLayout(radioPanel, BoxLayout.X_AXIS ));
		radioPanel.setMinimumSize(new Dimension(330, 25));
		radioPanel.setMaximumSize(new Dimension(330, 25));
		radioPanel.setPreferredSize(new Dimension(330, 25));
		radioPanel.setBackground(Color.lightGray);

		rlabelPanel = new JPanel();
		rlabelPanel.setLayout(new BoxLayout(rlabelPanel, BoxLayout.Y_AXIS ));
		rlabelPanel.setMinimumSize(new Dimension(120, 25));
		rlabelPanel.setMaximumSize(new Dimension(120, 25));
		rlabelPanel.setPreferredSize(new Dimension(120, 25));
		rlabelPanel.setBackground(Color.lightGray);


		rbPanel = new JPanel();
		rbPanel.setLayout(new BoxLayout(rbPanel, BoxLayout.X_AXIS ));
		rbPanel.setMinimumSize(new Dimension(160, 25));
		rbPanel.setMaximumSize(new Dimension(160, 25));
		rbPanel.setPreferredSize(new Dimension(160, 25));
		rbPanel.setBackground(Color.lightGray);

		labelPanel = new JPanel();
		labelPanel.setLayout(new BoxLayout(labelPanel, BoxLayout.Y_AXIS ));
		labelPanel.setMinimumSize(new Dimension(220, 25));
		labelPanel.setMaximumSize(new Dimension(220, 25));
		labelPanel.setPreferredSize(new Dimension(220, 25));
		labelPanel.setBackground(Color.lightGray);



		tfPanel = new JPanel();
		tfPanel.setLayout(new BoxLayout(tfPanel, BoxLayout.Y_AXIS ));
		tfPanel.setMinimumSize(new Dimension(60, 25));
		tfPanel.setMaximumSize(new Dimension(60, 25));
		tfPanel.setPreferredSize(new Dimension(60, 25));
		tfPanel.setBackground(Color.lightGray);

		//Panel nur f�r den Button
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.Y_AXIS ));
		buttonPanel.setMinimumSize(new Dimension(280, 25));
		buttonPanel.setMaximumSize(new Dimension(280, 25));
		buttonPanel.setPreferredSize(new Dimension(280, 25));
		buttonPanel.setBackground(Color.lightGray);


		numberOfClientsLabel = new JLabel("Number of connectable Clients: ", SwingConstants.RIGHT);
		numberOfClientsLabel.setMinimumSize(new Dimension(220, 25));
		numberOfClientsLabel.setMaximumSize(new Dimension(220, 25));
		numberOfClientsLabel.setPreferredSize(new Dimension(220, 25));

		numberOfClientsTF = new JTextField("1");

		//radiobutton

		rbLabel = new JLabel("Start Server: ", SwingConstants.RIGHT);
		rbLabel.setMinimumSize(new Dimension(120, 25));
		rbLabel.setMaximumSize(new Dimension(120, 25));
		rbLabel.setPreferredSize(new Dimension(120, 25));

		yrb = new JRadioButton("yes");
		nrb = new JRadioButton("no");
		yrb.setSelected(true);

		ButtonGroup grb = new ButtonGroup();
		grb.add( yrb ); grb.add( nrb );


		//start button
		startGameB = new JButton("Start");
		startGameB.setMinimumSize(new Dimension(100, 20));
		startGameB.setMaximumSize(new Dimension(100, 20));
		startGameB.setPreferredSize(new Dimension(100, 20));
		startGameB.addActionListener(this);



		labelPanel.add(numberOfClientsLabel);
		tfPanel.add(numberOfClientsTF);


		//radiobutton
		rlabelPanel.add(rbLabel);
		rbPanel.add(yrb);
		rbPanel.add(nrb);


		radioPanel.add(rlabelPanel);
		radioPanel.add(rbPanel);


		prefPanel.add(labelPanel);
		prefPanel.add(tfPanel);
		buttonPanel.add(startGameB);



		mainPanel.add(radioPanel);

		mainPanel.add(prefPanel);
		mainPanel.add(buttonPanel);

		//mainPanel.requestFocus();
		//addKeyListener(this);

		//Display the window.
		mainFrame.getContentPane().add(mainPanel);

		mainFrame.pack();
		mainFrame.setVisible(true);
		try {
			jbInit();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	/**
	 * This method is called up when a Component in this case the start button has an action listener
	 * and therefore is pressed. Now If you press the start button the actions defined in this method are taking place.
	 *
	 * @param event is also the default parament this method needs to have
	 */
	public void actionPerformed(ActionEvent event)
	{
		try
		{
			//wir abgefragt welcher radiobutton selectiert wurde. bei ja wird server gestartet...
			if(yrb.isSelected())
			{
				int numberOfClients = Integer.parseInt(
						numberOfClientsTF.getText());
				//legt eine Klasse an, die allen gemeinsame Felder und Methoden verwaltet
				S_common commonThings = new S_common(numberOfClients);
				//der Server_connectClient Thread wird hier gestartet...
				Server_connectClient progStart = new
				Server_connectClient(commonThings);
				progStart.start();
				startGameB.setEnabled(false);
			}
		}
		catch(Exception e)
		{
			System.out.println("Connection failed");
		}

		try
		{
			mainFrame.setVisible(false);

			//startet sofort nach Auswahl des servers die Client GUI
			new C_GUI();
		}
		catch(Exception e)
		{
		}
	}
	/**
	 * This is the main method of this class. Infact it's called up by entering "java GUIPack.S_GUI" into the shell.
	 * It creates the GUI by calling up its own constructor and it also defines the LookAndFeel which is like the Systems'.
	 * @param args is not in use
	 */
	public static void main(String[] args)
	{
		try
		{
			//das Aussehen der GUI wird hier definiert und zwar passt sie sich dem jeweiligen OS an (Linux, Windows, MacOS)
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		}
		catch (Exception e)
		{
		}
		//die gui erstellt sich selbst in ihrem constructor. Hier wird dann nur noch ein Object davon erzeugt!
		new S_GUI();
	}





	private void jbInit() throws Exception {
	}
}
