package commands;
import java.io.*;
import serverClient.*;


/**
 *	The class <i>C_getStoneCommand</i> is the <i>command</i> class
 *	that the client use to demand a new <i>stone</i> from the server.
 *	@author 	Winkler
 **/
public class C_getStoneCommand implements C_Command, Serializable
{
	/**
	 *	The empty <i>C_getStoneCommand()</i> constructor
	 */
	public C_getStoneCommand()
	{

	}
	
	private static final long serialVersionUID = 13L;
	
	/**
	 *	The <i>toString()</i> method can be called by the server or client
	 *	and always returns the same value
	 *	@return "C_getStoneCommand"
	 */
	public String toString()
	{
		return "C_getStoneCommand";
	}

	/**
	 *	The <i>execute(S_fromClient s)</i> method is called by
	 *	the client and executes the instructions of the <i>command</i>
	 *	in the class
	 *	@param s	SEE: S_fromClient class description
	 */
	public void execute(S_fromClient s)
	{
		s.setSendStone();
	}
}
