package serverClient;
import java.io.*;
import java.net.*;

/**
 *This class builds a server, that is waiting to receive connections by clients. If a user-defiened number of Clients has connected it starts a new Thread of the Class S_toClient and ends.
 *@author Winkler
 */
public class Server_connectClient extends Thread
{
	//Objekt der Klasse die die allen Threads auf der Serverseite gemeinsamen Felder und Methoden verwaltet...
	private S_common commonThings;
	//...wird dieser Klasse im Konstruktor �bergeben
	public Server_connectClient(S_common commonThings)
	{
		//System.out.println("Server_connectClient");
		this.commonThings = commonThings;
	}

	/**
	 * The run()-method is started automatically when a Thread is called on, this run() method continues to call on the go()-method.
	 */
	public void run()
	{
		try
		{
			go();
		}
		catch(Exception e){
			System.out.println("S_connectClient run() exception:");
			System.out.println(e);
		}
	}

	/**
	 * The go()-method builds a server with the portnumber 8181 on the
	 * localhost which accepts a certain number of clients (input Server.java)
	 * @exception IOException on wrong input
	 */
	public void go() throws IOException
	{
		//ein neuer server socket wird auf port 8181 erzeugt 16322
		ServerSocket serverso = new ServerSocket(16322);
		//der erste Client der sich verbindet erh�lt die id 1
		int id = 1;
		//auf der Console wird ausgegeben wie viele Clients erwartet werden
		System.out.println("server is running...(max. numberOfClients = "+commonThings.numberOfClients+")");
		//Es werden so lange Verbindungen von Clients angenommen, wie sich noch die vorgegebene Anzahl von Clients verbunden hat.
		
		while( id <= commonThings.numberOfClients )
		{
			//System.out.println("Server_connectClient");
			
			//es werden Verbindungen von Clients Zum Serversocket angenommen
			Socket clientso = serverso.accept();
			//F�r jeden Client der sich verbindet wird ein neuer Thread der Klasse S_toClient erzeugt...
			S_toClient sFred = new S_toClient(clientso, id, commonThings);
			//...und gestartet
			sFred.start();
			//...der Clientsocket wird an der dem jeweiligen Client entsprechenden Stelle in ein array eingetragen, ist momentan nicht weiter in Gebrauch
			commonThings.clientSockets[id-1] = clientso;
			//...auf der Serverconsole wird eine Ausgabe vorgenommen, sobald sich ein Client verbindet
			System.out.println("\n"+"Client"+id+" connected!");
			//die Schleifevariable wird erh�ht und stellt die id des naechsten zu verbindenden Clients dar, so noch welche erwartet werden
			id++;
		}
		//haben sich alle Clients verbunden wird ein Timer gestartet der den Spielcountdown in Gang setzt und sp�ter den Spielerhytmus vorgiebt
		commonThings.timer.schedule( commonThings.ticker, 0, 500 );
		//ein neuer Spielstein wird erzeugt (in der Spielsteinliste)
		//commonThings.createStone();
	}
}
